> For the complete documentation index, see [llms.txt](https://docs.console.zenlayer.com/api-reference/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.console.zenlayer.com/api-reference/bmc/vpc/createvpc.md).

# CreateVpc

## 1. API Description

This API (CreateVpc) is used to create a VPC.

#### Prerequisites

Before creating a VPC, call [`DescribeVpcAvailableRegions`](/api-reference/bmc/vpc/describevpcavailableregions.md) to check the availability regions for VPC creation.

{% hint style="info" %} <mark style="color:blue;">**Note**</mark>

* <mark style="color:blue;">The quantity of VPCs you can create in one availability region is limited. If you need more, please contact Zenlayer Support.</mark>
* <mark style="color:blue;">This API is an async API. A VPC ID list is returned after the creation request is sent. However, it does not mean the creation has been completed. The status of the VPC will be</mark> <mark style="color:blue;">`CREATING`</mark> <mark style="color:blue;">during the creation. You can use</mark> [<mark style="color:blue;"><mark style="color:purple;">DescribeVpcs<mark style="color:purple;"></mark>](/api-reference/bmc/vpc/describevpcs.md) <mark style="color:blue;">to query the status of the VPC. If the status changes from</mark> <mark style="color:blue;">`CREATING`</mark> <mark style="color:blue;">to</mark> <mark style="color:blue;">`AVAILABLE`</mark><mark style="color:blue;">, it means that the VPC has been created successfully;</mark> <mark style="color:blue;">`CREATE_FAILED`</mark> <mark style="color:blue;">means the VPC has been created failed. Any operations on the VPCs are not allowed while creating.</mark>
  {% endhint %}

## 2. Input Parameters

The following request parameter list only provides API request parameters.

| Parameter Name  | Required | Type                                                                 | Description                                                                                                                                                                               |
| --------------- | -------- | -------------------------------------------------------------------- | ----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
| vpcRegionId     | Yes      | String                                                               | Availability region ID of VPC.                                                                                                                                                            |
| cidrBlock       | Yes      | String                                                               | CIDR block of VPC.                                                                                                                                                                        |
| vpcName         | Yes      | String                                                               | <p>VPC name to be displayed.</p><p>This parameter can contain up to 64 characters. Only letters, numbers, - and periods (.) are supported.</p>                                            |
| resourceGroupId | No       | String                                                               | <p>Resource group ID.</p><p>If the value is not passed in, the VPC will be put into the default resource group. If no authorized default resource group found, the request will fail.</p> |
| tags            | No       | [TagAssociation](/api-reference/bmc/datastructure.md#tagassociation) | <p>Bound tags when creating resources.</p><p>Tag keys must be unique.</p>                                                                                                                 |

## 3. Output Parameters

| Parameter Name | Type   | Description                                                                                                           |
| -------------- | ------ | --------------------------------------------------------------------------------------------------------------------- |
| requestId      | String | <p>The unique request ID, which is returned for each request.</p><p>RequestId is required for locating a problem.</p> |
| vpcId          | String | VPC ID.                                                                                                               |

## 4. Code Example

{% tabs %}
{% tab title="Example" %}
Create a VPC in `CHI1`.

```json
POST /api/v2/bmc HTTP/1.1
Host: console.zenlayer.com
Content-Type: application/json
X-ZC-Action: CreateVpc
<Common Request Params>

Request:
{
  "vpcRegionId": "CHI1",
  "cidrBlock": "10.0.0.0/8",
  "vpcName": "1122"
}

Response:
{
  "requestId": "T3811A0E7-C250-40A2-96AD-08AD759E1BC2",
  "response": {
    "requestId": "T3811A0E7-C250-40A2-96AD-08AD759E1BC2",
    "vpcId": "835957634816289496"
  }
}
```

{% endtab %}
{% endtabs %}

## 5. Developer Resources

Zenlayer Cloud API 2.0 integrates [SDKs](/api-reference/api-introduction/toolkit/api-sdk.md)，to make it easier for you to call APIs. More programming languages will be supported.

## 6. Error Codes

The following only lists the error codes related to the API business logic. For other error codes, see [Common Error Codes](/api-reference/api-introduction/instruction/commonerrorcode.md).

| HTTP Status Code | Error Code | Description |
| ---------------- | ---------- | ----------- |
